{-#LANGUAGE OverloadedStrings #-}
{-#LANGUAGE TupleSections #-}
module Text.Tamper.Tags.Html.Attributes
where

import Data.Monoid
import Data.String

-- HTML5 attributes

accept :: (IsString t) => t -> (t, t)
accept = ("accept",)
acceptCharset :: (IsString t) => t -> (t, t)
acceptCharset = ("accept-charset",)
accesskey :: (IsString t) => t -> (t, t)
accesskey = ("accesskey",)
action :: (IsString t) => t -> (t, t)
action = ("action",)
alt :: (IsString t) => t -> (t, t)
alt = ("alt",)
async :: (IsString t) => t -> (t, t)
async = ("async",)
autocomplete :: (IsString t) => t -> (t, t)
autocomplete = ("autocomplete",)
autofocus :: (IsString t) => t -> (t, t)
autofocus = ("autofocus",)
autoplay :: (IsString t) => t -> (t, t)
autoplay = ("autoplay",)
challenge :: (IsString t) => t -> (t, t)
challenge = ("challenge",)
charset :: (IsString t) => t -> (t, t)
charset = ("charset",)
checked :: (IsString t) => t -> (t, t)
checked = ("checked",)
cite :: (IsString t) => t -> (t, t)
cite = ("cite",)
class_ :: (IsString t) => t -> (t, t)
class_ = ("class",)
cols :: (IsString t) => t -> (t, t)
cols = ("cols",)
colspan :: (IsString t) => t -> (t, t)
colspan = ("colspan",)
content :: (IsString t) => t -> (t, t)
content = ("content",)
contenteditable :: (IsString t) => t -> (t, t)
contenteditable = ("contenteditable",)
contextmenu :: (IsString t) => t -> (t, t)
contextmenu = ("contextmenu",)
controls :: (IsString t) => t -> (t, t)
controls = ("controls",)
coords :: (IsString t) => t -> (t, t)
coords = ("coords",)
data_ :: (IsString t) => t -> (t, t)
data_ = ("data",)
datetime :: (IsString t) => t -> (t, t)
datetime = ("datetime",)
defer :: (IsString t) => t -> (t, t)
defer = ("defer",)
dir :: (IsString t) => t -> (t, t)
dir = ("dir",)
disabled :: (IsString t) => t -> (t, t)
disabled = ("disabled",)
draggable :: (IsString t) => t -> (t, t)
draggable = ("draggable",)
enctype :: (IsString t) => t -> (t, t)
enctype = ("enctype",)
for :: (IsString t) => t -> (t, t)
for = ("for",)
form :: (IsString t) => t -> (t, t)
form = ("form",)
formaction :: (IsString t) => t -> (t, t)
formaction = ("formaction",)
formenctype :: (IsString t) => t -> (t, t)
formenctype = ("formenctype",)
formmethod :: (IsString t) => t -> (t, t)
formmethod = ("formmethod",)
formnovalidate :: (IsString t) => t -> (t, t)
formnovalidate = ("formnovalidate",)
formtarget :: (IsString t) => t -> (t, t)
formtarget = ("formtarget",)
headers :: (IsString t) => t -> (t, t)
headers = ("headers",)
height :: (IsString t) => t -> (t, t)
height = ("height",)
hidden :: (IsString t) => t -> (t, t)
hidden = ("hidden",)
high :: (IsString t) => t -> (t, t)
high = ("high",)
href :: (IsString t) => t -> (t, t)
href = ("href",)
hreflang :: (IsString t) => t -> (t, t)
hreflang = ("hreflang",)
httpEquiv :: (IsString t) => t -> (t, t)
httpEquiv = ("http-equiv",)
icon :: (IsString t) => t -> (t, t)
icon = ("icon",)
id :: (IsString t) => t -> (t, t)
id = ("id",)
ismap :: (IsString t) => t -> (t, t)
ismap = ("ismap",)
item :: (IsString t) => t -> (t, t)
item = ("item",)
itemprop :: (IsString t) => t -> (t, t)
itemprop = ("itemprop",)
keytype :: (IsString t) => t -> (t, t)
keytype = ("keytype",)
label :: (IsString t) => t -> (t, t)
label = ("label",)
lang :: (IsString t) => t -> (t, t)
lang = ("lang",)
list :: (IsString t) => t -> (t, t)
list = ("list",)
loop :: (IsString t) => t -> (t, t)
loop = ("loop",)
low :: (IsString t) => t -> (t, t)
low = ("low",)
manifest :: (IsString t) => t -> (t, t)
manifest = ("manifest",)
max :: (IsString t) => t -> (t, t)
max = ("max",)
maxlength :: (IsString t) => t -> (t, t)
maxlength = ("maxlength",)
media :: (IsString t) => t -> (t, t)
media = ("media",)
method :: (IsString t) => t -> (t, t)
method = ("method",)
min :: (IsString t) => t -> (t, t)
min = ("min",)
multiple :: (IsString t) => t -> (t, t)
multiple = ("multiple",)
name :: (IsString t) => t -> (t, t)
name = ("name",)
novalidate :: (IsString t) => t -> (t, t)
novalidate = ("novalidate",)
onbeforeonload :: (IsString t) => t -> (t, t)
onbeforeonload = ("onbeforeonload",)
onbeforeprint :: (IsString t) => t -> (t, t)
onbeforeprint = ("onbeforeprint",)
onblur :: (IsString t) => t -> (t, t)
onblur = ("onblur",)
oncanplay :: (IsString t) => t -> (t, t)
oncanplay = ("oncanplay",)
oncanplaythrough :: (IsString t) => t -> (t, t)
oncanplaythrough = ("oncanplaythrough",)
onchange :: (IsString t) => t -> (t, t)
onchange = ("onchange",)
oncontextmenu :: (IsString t) => t -> (t, t)
oncontextmenu = ("oncontextmenu",)
onclick :: (IsString t) => t -> (t, t)
onclick = ("onclick",)
ondblclick :: (IsString t) => t -> (t, t)
ondblclick = ("ondblclick",)
ondrag :: (IsString t) => t -> (t, t)
ondrag = ("ondrag",)
ondragend :: (IsString t) => t -> (t, t)
ondragend = ("ondragend",)
ondragenter :: (IsString t) => t -> (t, t)
ondragenter = ("ondragenter",)
ondragleave :: (IsString t) => t -> (t, t)
ondragleave = ("ondragleave",)
ondragover :: (IsString t) => t -> (t, t)
ondragover = ("ondragover",)
ondragstart :: (IsString t) => t -> (t, t)
ondragstart = ("ondragstart",)
ondrop :: (IsString t) => t -> (t, t)
ondrop = ("ondrop",)
ondurationchange :: (IsString t) => t -> (t, t)
ondurationchange = ("ondurationchange",)
onemptied :: (IsString t) => t -> (t, t)
onemptied = ("onemptied",)
onended :: (IsString t) => t -> (t, t)
onended = ("onended",)
onerror :: (IsString t) => t -> (t, t)
onerror = ("onerror",)
onfocus :: (IsString t) => t -> (t, t)
onfocus = ("onfocus",)
onformchange :: (IsString t) => t -> (t, t)
onformchange = ("onformchange",)
onforminput :: (IsString t) => t -> (t, t)
onforminput = ("onforminput",)
onhaschange :: (IsString t) => t -> (t, t)
onhaschange = ("onhaschange",)
oninput :: (IsString t) => t -> (t, t)
oninput = ("oninput",)
oninvalid :: (IsString t) => t -> (t, t)
oninvalid = ("oninvalid",)
onkeydown :: (IsString t) => t -> (t, t)
onkeydown = ("onkeydown",)
onkeyup :: (IsString t) => t -> (t, t)
onkeyup = ("onkeyup",)
onload :: (IsString t) => t -> (t, t)
onload = ("onload",)
onloadeddata :: (IsString t) => t -> (t, t)
onloadeddata = ("onloadeddata",)
onloadedmetadata :: (IsString t) => t -> (t, t)
onloadedmetadata = ("onloadedmetadata",)
onloadstart :: (IsString t) => t -> (t, t)
onloadstart = ("onloadstart",)
onmessage :: (IsString t) => t -> (t, t)
onmessage = ("onmessage",)
onmousedown :: (IsString t) => t -> (t, t)
onmousedown = ("onmousedown",)
onmousemove :: (IsString t) => t -> (t, t)
onmousemove = ("onmousemove",)
onmouseout :: (IsString t) => t -> (t, t)
onmouseout = ("onmouseout",)
onmouseover :: (IsString t) => t -> (t, t)
onmouseover = ("onmouseover",)
onmouseup :: (IsString t) => t -> (t, t)
onmouseup = ("onmouseup",)
onmousewheel :: (IsString t) => t -> (t, t)
onmousewheel = ("onmousewheel",)
ononline :: (IsString t) => t -> (t, t)
ononline = ("ononline",)
onpagehide :: (IsString t) => t -> (t, t)
onpagehide = ("onpagehide",)
onpageshow :: (IsString t) => t -> (t, t)
onpageshow = ("onpageshow",)
onpause :: (IsString t) => t -> (t, t)
onpause = ("onpause",)
onplay :: (IsString t) => t -> (t, t)
onplay = ("onplay",)
onplaying :: (IsString t) => t -> (t, t)
onplaying = ("onplaying",)
onprogress :: (IsString t) => t -> (t, t)
onprogress = ("onprogress",)
onpropstate :: (IsString t) => t -> (t, t)
onpropstate = ("onpropstate",)
onratechange :: (IsString t) => t -> (t, t)
onratechange = ("onratechange",)
onreadystatechange :: (IsString t) => t -> (t, t)
onreadystatechange = ("onreadystatechange",)
onredo :: (IsString t) => t -> (t, t)
onredo = ("onredo",)
onresize :: (IsString t) => t -> (t, t)
onresize = ("onresize",)
onscroll :: (IsString t) => t -> (t, t)
onscroll = ("onscroll",)
onseeked :: (IsString t) => t -> (t, t)
onseeked = ("onseeked",)
onseeking :: (IsString t) => t -> (t, t)
onseeking = ("onseeking",)
onselect :: (IsString t) => t -> (t, t)
onselect = ("onselect",)
onstalled :: (IsString t) => t -> (t, t)
onstalled = ("onstalled",)
onstorage :: (IsString t) => t -> (t, t)
onstorage = ("onstorage",)
onsubmit :: (IsString t) => t -> (t, t)
onsubmit = ("onsubmit",)
onsuspend :: (IsString t) => t -> (t, t)
onsuspend = ("onsuspend",)
ontimeupdate :: (IsString t) => t -> (t, t)
ontimeupdate = ("ontimeupdate",)
onundo :: (IsString t) => t -> (t, t)
onundo = ("onundo",)
onunload :: (IsString t) => t -> (t, t)
onunload = ("onunload",)
onvolumechange :: (IsString t) => t -> (t, t)
onvolumechange = ("onvolumechange",)
onwaiting :: (IsString t) => t -> (t, t)
onwaiting = ("onwaiting",)
open :: (IsString t) => t -> (t, t)
open = ("open",)
optimum :: (IsString t) => t -> (t, t)
optimum = ("optimum",)
pattern :: (IsString t) => t -> (t, t)
pattern = ("pattern",)
ping :: (IsString t) => t -> (t, t)
ping = ("ping",)
placeholder :: (IsString t) => t -> (t, t)
placeholder = ("placeholder",)
preload :: (IsString t) => t -> (t, t)
preload = ("preload",)
pubdate :: (IsString t) => t -> (t, t)
pubdate = ("pubdate",)
radiogroup :: (IsString t) => t -> (t, t)
radiogroup = ("radiogroup",)
readonly :: (IsString t) => t -> (t, t)
readonly = ("readonly",)
rel :: (IsString t) => t -> (t, t)
rel = ("rel",)
required :: (IsString t) => t -> (t, t)
required = ("required",)
reversed :: (IsString t) => t -> (t, t)
reversed = ("reversed",)
rows :: (IsString t) => t -> (t, t)
rows = ("rows",)
rowspan :: (IsString t) => t -> (t, t)
rowspan = ("rowspan",)
sandbox :: (IsString t) => t -> (t, t)
sandbox = ("sandbox",)
scope :: (IsString t) => t -> (t, t)
scope = ("scope",)
scoped :: (IsString t) => t -> (t, t)
scoped = ("scoped",)
seamless :: (IsString t) => t -> (t, t)
seamless = ("seamless",)
selected :: (IsString t) => t -> (t, t)
selected = ("selected",)
shape :: (IsString t) => t -> (t, t)
shape = ("shape",)
size :: (IsString t) => t -> (t, t)
size = ("size",)
sizes :: (IsString t) => t -> (t, t)
sizes = ("sizes",)
span :: (IsString t) => t -> (t, t)
span = ("span",)
spellcheck :: (IsString t) => t -> (t, t)
spellcheck = ("spellcheck",)
src :: (IsString t) => t -> (t, t)
src = ("src",)
srcdoc :: (IsString t) => t -> (t, t)
srcdoc = ("srcdoc",)
start :: (IsString t) => t -> (t, t)
start = ("start",)
step :: (IsString t) => t -> (t, t)
step = ("step",)
style :: (IsString t) => t -> (t, t)
style = ("style",)
subject :: (IsString t) => t -> (t, t)
subject = ("subject",)
summary :: (IsString t) => t -> (t, t)
summary = ("summary",)
tabindex :: (IsString t) => t -> (t, t)
tabindex = ("tabindex",)
target :: (IsString t) => t -> (t, t)
target = ("target",)
title :: (IsString t) => t -> (t, t)
title = ("title",)
type_ :: (IsString t) => t -> (t, t)
type_ = ("type",)
usemap :: (IsString t) => t -> (t, t)
usemap = ("usemap",)
value :: (IsString t) => t -> (t, t)
value = ("value",)
width :: (IsString t) => t -> (t, t)
width = ("width",)
wrap :: (IsString t) => t -> (t, t)
wrap = ("wrap",)
xmlns :: (IsString t) => t -> (t, t)
xmlns = ("xmlns",)

-- | These are "special"

on :: (Monoid t, IsString t) => t -> t -> (t, t)
on event = ("on" <> event,)
dataAttrib :: (Monoid t, IsString t) => t -> t -> (t, t)
dataAttrib name = ("data-" <> name,)
